#include<math.h>
#include<stdio.h>
#define e 2.7182818
#define pi 3.141592
#define SWF 20000

double fa=0.;
double fb=0.;
double fc=0.;
double fsd=0.;
double fsq=0.;
double theta=0.;
double magni=0.;
double omega=0.;
int secter=0;
double t1,t2,t0,ts=0.;
double cnt=0;
double sat, sbt, sct=0;
int pwma,pwmb,pwmc=0;
double vin=0.;
int n=0;
double tga,tgb,tgc=0.;



__declspec(dllexport)void RUNSIMUSER(double t, double delt, double *in, double *out)
{
	fa=		in[0];
	fb=		in[1];
	vin=	in[2];
	ts=		in[3];

	fc=-(fa+fb);

	fsd=(2*fa-fb-fc)/3;
	fsq=(fb-fc)/sqrt(3.0);

	theta=atan2(fsq,fsd);
	magni=sqrt(pow(fsd,2)+pow(fsd,2));

	if(theta>=2*pi)
	{//theta 2*pi  ʵ 
		theta=theta/(2*pi);
	}
	if(fsq>0)
	{
		if(fsd/fsq>0)
		{
		if(fsd/fsq<sqrt(3.0))
			secter = 1;
		}
		if(fsd/fsq<0)
		{
		if(fsd/fsq>-sqrt(3.0)
			secter = 3;
		}
		
	}
	else secter=2;

	if(fsq<0)
		{
		if(fsd/fsq>0)
		{
		if(fsd/fsq<sqrt(3.0))
			secter = 4;
		}
		if(fsd/fsq<0)
		{
		if(fsd/fsq>-sqrt(3.0)
			secter = 6;
		}
		
	}
	else secter=5;

	if(cnt>2*ts/delt)
	{
		
	t1=(sqrt(3.0)*ts*(magni/vin)*sin((secter*pi)/3-theta))/delt;
	t2=(sqrt(3.0)*ts*(magni/vin)*sin(omega))/delt;
	t0=ts/delt-t1-t2;
	//on sequence
	switch (secter)
	{
		case 1 :
			tga=t0/2;
			tgb=t0/2+t1;
			tgc=t0/2+t1+t2;
		case 2 :
			tga=t0/2+t2;
			tgb=t0/2;
			tgc=t0/2+t1+t2;
		case 3 :
			tga=t0/2+t1+t2;
			tgb=t0/2;
			tgc=t0/2+t1;
		case 4:
			tga=t0/2+t1+t2;
			tgb=t0/2+t2;
			tgc=t0/2;
		case 5:
			tga=t0/2+t1;
			tgb=t0/2+t1+t2;
			tgc=t0/2;
		case 6 :
			tga=t0/2;
			tgb=t0/2+t1+t2;
			tgc=t0/2+t2;
		default :
			tga=0;
			tgb=0;
			tgc=0;
	}
	}
if (cnt<ts/delt)
{
 if(tga==sat)
 {
	 pwma=1;
	 sat+=delt;
 }
 else pwma=0;
 if(tgb==sbt)
 {
	pwmb=1;
	sbt+=delt;
 }
 else pwmb=0;
 if(tgc==sct)
 {
	 pwmc=1;
	sct+=delt;
 }
 else pwmc=0;
 }
			//off sequence
// tga=ts-tga;
// tgb=ts-tgb;
// tgc=ts-tgc;
// 
// if (cnt>=2*ts/delt)
//{
// if(tga==sat)
// {
//	 pwma=1;
//	 sat+=delt;
// }
// else pwma=0;
// if(tgb==sbt)
// {
//	pwmb=1;
//	sbt+=delt;
// }
// else pwmb=0;
// if(tgc==sct)
// {
//	 pwmc=1;
////	sct+=delt;
//// }
// else pwmc=0;
// }
 if (cnt>2*ts/delt)
	 cnt=0;
 else cnt+=0.01;
	out[0]=		pwma;
	out[1]=		pwmb;
	out[2]=		pwmc;
	out[3]=		secter;
	out[4]=		theta;
	out[5]=		t2;



	}