#include<math.h>
#include<stdio.h>
#define e 2.7182818
#define pi 3.141592

double fa=0.;
double fb=0.;
double fc=0.;
double fsd=0.;
double fsq=0.;
double theta=0.;
double magni=0.;
double omega=0.;
int secter=0;
double t1,t2,t0,ts=0.;
double cnt=0;
double sat=0., sbt, sct=0;
int pwma,pwmb,pwmc=0;
double vin=0.;
int n=0;
double tga,tgb,tgc=0.;
double tga2,tgb2,tgc2=0.;
double sat2,sbt2,sct2=0.;



__declspec(dllexport)void RUNSIMUSER(double t, double delt, double *in, double *out)
{
	fa=		in[0];
	fb=		in[1];
	vin=	in[2];
	ts=		in[3];

	if (cnt>=2*ts) {cnt=0;}
	else {cnt+=delt;}

	fc=-(fa+fb);
	fsd=(2*fa-fb-fc)/3;
	fsq=(fb-fc)/sqrt(3.0);

	theta=atan2(fsq,fsd);
	magni=sqrt(fsd*fsd+fsq*fsq);

	if(theta>=2*pi)
	{//theta 2*pi  ʵ 
		theta=theta/(2*pi);
	}
	if(fsq>0)
	{
		if(fsq/fsd>0)
		{
		if(fsq/fsd<sqrt(3.0))
			secter = 1;
        else secter=2;
		}
		else if (fsq/fsd<0)
		{
		if(fsq/fsd>-sqrt(3.0))
			secter = 3;
        else secter=2;
		}

	}
	
	if(fsq<=0)
		{
		if(fsq/fsd>0)
		{
		if(fsq/fsd<sqrt(3.0))
			secter = 4;
          else secter=5;
		}
		else if(fsq/fsd<0)
		{
		if(fsq/fsd>-sqrt(3.0))
			secter = 6;
         else secter=5;
		}
      
		
	}
	


	if(cnt==0)
	{
		t1=sqrt(3.0)*ts*(magni/vin)*(sin((secter*pi)/3)*cos(theta)-cos((secter*pi)/3)*sin(theta));
		t2=sqrt(3.0)*ts*(magni/vin)*(sin(theta)*cos(((secter-1)*pi)/3)-cos(theta)*sin(((secter-1)*pi)/3));
		t0=ts-t1-t2;
	
	////on sequence
		if(secter==1){
			tga=t0/2;
			tgb=t0/2+t1;
			tgc=t0/2+t1+t2;
		}
		/*case 2 :*/
        else if(secter==2){
			tga=t0/2+t2;
			tgb=t0/2;
			tgc=t0/2+t1+t2;
		}
		/*case 3 :*/
        else if(secter==3){
			tga=t0/2+t1+t2;
			tgb=t0/2;
			tgc=t0/2+t1;
		}
		/*case 4:*/
        else if(secter==4){
			tga=t0/2+t1+t2;
			tgb=t0/2+t2;
			tgc=t0/2;
		}
		/*case 5:*/
        else if(secter==5){
			tga=t0/2+t1;
			tgb=t0/2+t1+t2;
			tgc=t0/2;
		}
		/*case 6 :*/
        else if(secter==6){
			tga=t0/2;
			tgb=t0/2+t1+t2;
			tgc=t0/2+t2;
		}

//
			//off sequence
		if(secter==1){
			tga2=t0/2+t1+t2;
			tgb2=t0/2+t2;
			tgc2=t0/2;
		}
		/*case 2 :*/
        else if(secter==2){
			tga2=t0/2+t1;
			tgb2=t0/2+t1+t2;
			tgc2=t0/2;
		}
		/*case 3 :*/
        else if(secter==3){
			tga2=t0/2;
			tgb2=t0/2+t1+t2;
			tgc2=t0/2+t2;
		}
		/*case 4:*/
        else if(secter==4){
			tga2=t0/2;
			tgb2=t0/2+t1;
			tgc2=t0/2+t1+t2;
		}
		/*case 5:*/
        else if(secter==5){
			tga2=t0/2+t2;
			tgb2=t0/2;
			tgc2=t0/2+t1+t2;
		}
		/*case 6 :*/
        else if(secter==6){
			tga2=t0/2+t1+t2;
			tgb2=t0/2;
			tgc2=t0/2+t1;
		}
	}
	if(cnt>tga){//a ġ 
		pwma=1;
		if(cnt>(2*ts-tga)){
			pwma=0;
		}
	}
	if(cnt>tgb){//a ġ 
		pwmb=1;
		if(cnt>(2*ts-tgb)){
			pwmb=0;
		}
	}

	if(cnt>tgc){//a ġ 
		pwmc=1;
		if(cnt>(2*ts-tgc)){
			pwmc=0;
		}
	}




		out[0]=		pwma;
		out[1]=		pwmb;
		out[2]=		pwmc;
		out[3]=		tga;
		out[4]=		cnt;
		out[5]=		tgc;
}